        function [exeAdj] = AggExecutions_Core_l1_after(mess)
            % Output: columns
            %   1       -> row event beginning
            %   2       -> row event ending
            %   4       -> transaction price (unit price obtained)
            %--------------------------------------------------------------
            % NOTE: executions are aggregated if they occur at the same
            % time. use median price for aggregated transactions.
            % Procedure aggregates split transactions that were separated
            % by e.g. cancelation and thus misssed by 1st order procedure.
            %--------------------------------------------------------------

            % Helpers
            bl          = size(mess,1);

            % Collection matrix
            exeAdj      = zeros(bl,3);

            jSave = 1;
            jBook = 1;

            while jBook <= bl
                    k=0;
                    while jBook+k+1 <= bl && ...
                            (abs(mess(jBook + k + 1,1) - mess(jBook,1))<eps) 
                        % Check for ...
                        % ... not end of book, same time,  
                        k=k+1;
                    end

                    % Save trade information
                    % ... postions and volume of trade
                    exeAdj(jSave,1:2) = [jBook, jBook+k];

                    % ... price (Unit price obtained)
                    exeAdj(jSave,3) = nanmedian(mess(jBook:jBook+k,2));
 
                    % Update loop variables
                    jBook = jBook + k + 1;
                    jSave = jSave + 1;

            end
            % Remove unneeded parts
            exeAdj = exeAdj(1:jSave-1,:);

        end
