function [LLE_arr,LLE_adpt_arr,SPEC_arr,SPEC_adpt_arr]=LLE_SPEC_B_J_est(data_a1,data_a2,H,startt,endt,SCov_mat,B_vec,...
    nkex,phi_ctr,K,J_vec,J_p_vec,est_spec_adpt)
%% LLE_SPEC_B_J_est
%------------------------------------------------------------

%dimensions
B_n=length(B_vec);
J_n=length(J_vec);

% Create empty arrays
LLE_arr=NaN*zeros(3,B_n,J_n);
LLE_adpt_arr=LLE_arr;
SPEC_arr=LLE_arr;
SPEC_adpt_arr=LLE_arr;


% Loop over B,J inputs and compute estimates
%-------------------------------------------------------

for i=1:B_n
    
    for j=1:J_n
        
        %choose block length and cutoff
        B=B_vec(i);
        J=J_vec(j);
        J_p=J_p_vec(j);
            
            % LLE
            [Sigma_out,~,~,~,~,~,~]=lle_cov_oracle_async_corrd(data_a1,data_a2,H,startt,endt,B,SCov_mat,1,nkex,phi_ctr,1,(J*ones(B,1)));                  
             LLE_arr(:,i,j)=[Sigma_out(1,1); Sigma_out(2,2); Sigma_out(1,2)];
             
              [Sigma_out,~,~,~,~,~,~]=lle_cov_corrd(data_a1,data_a2,H,startt,endt,B,1,nkex,phi_ctr,1,J_p,K,(J*ones(B,1)));
             LLE_adpt_arr(:,i,j)=[Sigma_out(1,1); Sigma_out(2,2); Sigma_out(1,2)];
             

             % SPEC
              [Sigma_out,~,~,~,~,~,~]=spec_cov_oracle_async_corrd(data_a1,data_a2,H,startt,endt,B,SCov_mat,1,nkex,phi_ctr,1,(J*ones(B,1)));
              SPEC_arr(:,i,j)=[Sigma_out(1,1); Sigma_out(2,2); Sigma_out(1,2)];
              
              if est_spec_adpt>0
                    [Sigma_out,~,~,~,~,~,~]=spec_cov_corrd(data_a1,data_a2,H,startt,endt,B,1,nkex,phi_ctr,1,J_p,K,(J*ones(B,1)));
              else
                    Sigma_out=NaN*zeros(2);
              end
              SPEC_adpt_arr(:,i,j)=[Sigma_out(1,1); Sigma_out(2,2); Sigma_out(1,2)];
              
    end
end