function [AC] = ACov(dx,r)
%% ACov
%------------------------------------------------------------
% Computes autocovariance  of demeaned process
%--------------------------------------------------------------
% INPUT:
% dx -> (nx1) vector containing realizeation of demeaned process
% r -> lag order
%--------------------------------------------------------------
% OUTPUT:
% AC -> autocovariance of order r
% -------------------------------------------------------------------------
%
% Peter Malec, March 3, 2014
%
% -------------------------------------------------------------------------
%       
%% Compute Autocovariance

% adjust
dx=dx(:);

% autocovariances of order r
AC=dx(1:(end-r))'*dx((1+r):end)/(length(dx)-r);





