function [AC] = ACov_fast(dx,r)
%% ACov_fast
%------------------------------------------------------------
% Computes autocovariance  of demeaned process
%--------------------------------------------------------------
% INPUT:
% dx -> (nx1) vector containing realizeation of demeaned process
% r -> lag order
%--------------------------------------------------------------
% OUTPUT:
% AC -> autocovariance of order r
% -------------------------------------------------------------------------
%
% Peter Malec, May 4, 2014
%
% -------------------------------------------------------------------------
%       
% Note: zero returns are accounted for
%       
%% Compute Autocovariance

% adjust
%dx=dx(:);

% get data matrix w/o zeros
dx_m=[dx(1:(end-r)) dx((1+r):end)];
dx_m(all(dx_m==0,2),:)=[];

% autocovariances of order r
AC=dx_m(:,1)'*dx_m(:,2)/(length(dx)-r);





