function [AC] = ACov_nnorm(dx,r)
%% ACov_nnorm
%------------------------------------------------------------
% Computes unnormalized autocovariance 
%--------------------------------------------------------------
% INPUT:
% dx -> (nx1) vector containing realizeation of process
% r -> lag order
%--------------------------------------------------------------
% OUTPUT:
% AC -> non-normalized autocovariance of order r
% -------------------------------------------------------------------------
%
% Peter Malec, March 3, 2014
%
% -------------------------------------------------------------------------
%       
%% Compute Autocovariance

% adjust
dx=dx(:);

% autocovariances of order r
AC=dx(1:(end-r))'*dx((1+r):end);





