function [AC] = ACov_nnorm_fast(dx,r)
%% ACov_nnorm_fast
%------------------------------------------------------------
% Computes unnormalized autocovariance 
%--------------------------------------------------------------
% INPUT:
% dx -> (nx1) vector containing realizeation of process
% r -> lag order
%--------------------------------------------------------------
% OUTPUT:
% AC -> non-normalized autocovariance of order r
% -------------------------------------------------------------------------
%
% Peter Malec, May 4, 2014
%
% -------------------------------------------------------------------------
%       
% Note: zero returns are accounted for
%
%% Compute Autocovariance

% adjust
%dx=dx(:);

% get data matrix w/o zeros
dx_m=[dx(1:(end-r)) dx((1+r):end)];
dx_m(all(dx_m==0,2),:)=[];


% autocovariances of order r
AC=dx_m(:,1)'*dx_m(:,2);





