function Noise_EST_simp_proc(ticker,tdate,typed,cl_ind,rev_ind,inpath,sourced,outpath)
%% Noise_EST_simp_proc
%--------------------------------------------------------------
% Estimate Noise Variance 
%--------------------------------------------------------------
% INPUT:
% ticker ->  ticker symbol (string)
% tdate   -> data in matlab format
% cl_ind    -> if ==1, data cleaned according to proc by BNHLS(2009) is used
% rev_ind    -> if ==1, only obs with price revisions are used
% inpath     -> path for loading data
% sourced   -> data source
% outpath  -> path for saving
%--------------------------------------------------------------
%
% Peter Malec,  March 26 2014 
%
% -------------------------------------------------------------------------
%   
%% Load Data

% clean?
if cl_ind==1
     cl_str='cl';            % cleaning string for output file
else
     cl_str='ncl';
end


% check for existence of files
%-----------------------------------------------------------------------------------
name=strcat(inpath,ticker,filesep,ticker,'_',datestr(tdate,'yyyymmdd'),'_',typed,'_',cl_str,'.mat');
index=isequal(exist(name,'file'),2);


if index
%---------------------------------------------------------
% Load
load(name);
if isequal(typed,'trades')
    midprice=trades;
end
if rev_ind==1
   midprice=keep_rev(midprice,2);
end
% -------------------------------------------------------------------------
%   
%% Estimate Noise Variance

%noise var
eta_est=noise_cov_est(midprice(:,2),'cov');
if eta_est<=0
     eta_est=noise_cov_est(midprice(:,2),'var');
end
% -------------------------------------------------------------------------
%   
%% Save Results

% revisions?
if rev_ind==1
     rev_str='_rev';            
else
     rev_str='';     
end

%name
basename=strcat(outpath,ticker,filesep,'noise_est_',ticker,'_',sourced,'_',datestr(tdate,'yyyymmdd'),typed,cl_str,rev_str);

%save output
save(strcat(basename,'.mat'),'eta_est')
% -------------------------------------------------------------------------
% 
%% files do not exist: do nothing

else
    disp(['Data missing for the following ticker: ' ticker '. Skip day.'])
end



    
  
    