function [block_st,block_end,hs,ks]=block_start_end(h,s_block)
%% block_start_end
%--------------------------------------------------------------
% creates grid of block bounds
%
%--------------------------------------------------------------
% INPUT:
% h-> block length
% s_block -> determines which block is shorter: 'first' or 'last' 
%--------------------------------------------------------------
% OUTPUT:
% block_st -> (Bx1) vector of block beginnings
% block_end -> (Bx1) vector of block ends
% hs -> length of shorter block
% ks -> index of shorter block
% -------------------------------------------------------------------------
%
% Peter Malec, August 12, 2012 
%
% -------------------------------------------------------------------------
%       
%% start and end of each block (# of elements gives # blocks)-


% which block ist shorter?

if isequal(s_block,'first')  % first block
    
    % vector of bounds
    block_v=(fliplr((1:-h:0)))';
    
    if block_v(1)==0         % check if unit interval can be divided in equal blocks of length h
        block_st=block_v(1:end-1);
        block_end=block_v(2:end);
    else                                % first block is shorter !!
     block_st=[0; block_v(1:end-1)];
     block_end=block_v;
    end

    hs=block_end(1)-block_st(1);    %length of shorter block
    
    % block index for short block
    ks=1;

else        % last block
    
    % vector of bounds
    block_v=(0:h:1)';

    if block_v(end)==1         % check if unit interval can be divided in equal blocks of length h
        block_st=block_v(1:end-1);
        block_end=block_v(2:end);
    else                                % last block is shorter !!
     block_st=block_v;
     block_end=[block_v(2:end); 1];
    end
    
    hs=block_end(end)-block_st(end);    %length of shorter block
    
    % block index for short block
    ks=length(block_st);

end

