function eta_est_vec=comp_noise_ac(inpathnoise,ticker,tdate,sourced,typed,cl_ind,rev_ind,Q_max,alpha,skips)
%% comp_noise_ac
%------------------------------------------------------------------
% computes autocovariances of noise process
%---------------------------------------------------------
%
%% Preparations

%input check
if Q_max<=1
    error('Q_max needs to be >1!')
end

% clean?
if cl_ind==1
    cl_str='cl';            % cleaning string for output file
else
    cl_str='ncl';
end

% revisions?
if rev_ind==1
     rev_str='_rev';            
else
     rev_str='';     
end
% -------------------------------------------------------------------------
%
%% Noise

    % alpha_label
    alpha_l=num2str(alpha);
    alpha_l(alpha_l=='.')='';
   if ~isempty(skips)
       name3=strcat(inpathnoise,ticker,'\\noise_est_',ticker,'_',sourced,'_',datestr(tdate,'yyyymmdd'),typed,cl_str,rev_str,'_alpha',alpha_l,'_Q',int2str(Q_max),'_ss',int2str(skips),'_add_res.mat');
    else
        name3=strcat(inpathnoise,ticker,'\\noise_est_',ticker,'_',sourced,'_',datestr(tdate,'yyyymmdd'),typed,cl_str,rev_str,'_alpha',alpha_l,'_Q',int2str(Q_max),'_add_res.mat');
    end

index3=isequal(exist(name3,'file'),2);
    
if index3
%---------------------------------------------------------
    indat=iload(name3,'add_res');
    
    %get differences between ACs
    AC_diff_vec=indat.add_res.AC_diff_vec;
    
    % vector of estimates of noise autocovariances
    eta_est_vec=flipud(cumsum(flipud(AC_diff_vec(1:(end-1)))));  %((R+1)x1) vector (R=Q-1): lag order increasing
   
else
    eta_est_vec=NaN;
end





