function J_max=find_maxJ_const_specv(weights,cv)
%% find_maxJ_const_specv
%--------------------------------------------------------------
% determines spectral cutoff for specv estimator by finding abs(weights) <= cv
%--------------------------------------------------------------
% INPUT:
% weights -> (nhx1) vector of weights
% cv -> critival value, default: 1e-6
%--------------------------------------------------------------
% OUTPUT:
% J_max -> spectral cutoff
% -------------------------------------------------------------------------
%
% Peter Malec, April 2, 2012
%
% -------------------------------------------------------------------------
%       
%% Check Inputs

% critical value
if nargin<2
    cv=1e-6;
end

% largest frequency possible
nh=length(weights);
% -------------------------------------------------------------------------
%       
%% Find Spectral Cutoff

% starting value for weight
weight_W=1;

% starting cutoff
j=1;

% loop for further frequencies
%--------------------------------
while (weight_W >= cv) && (j<= nh) 

    weight_W=abs(weights(j,1));  

    j=j+1;

end

% Output
J_max=j-1;