function mat_ind=return_overlap(t_xk,tl_xk,t_yk,tl_yk)
%% return_overlap
%--------------------------------------------------------------------------------
% computes length of overlap of return spells of x,y
%-------------------------------------------------------------------------------
% INPUTS:
% t_xk    -> (n_k_x x 1) vector of observations times of x on block
% tl_xk    -> (n_k_x x 1) vector of lagged observations times of x on block
%--------------------------------------------------------------
% OUTPUT:
% mat_ind (n_k_x x n_k_y) matrix of lengths of overlap of return spells of x,y (else 0)
% -------------------------------------------------------------------------
%
% Peter Malec, August 18, 2012 
%
% -------------------------------------------------------------------------
%       
%% compute overlaps

% number of observations of x
n_k_x=length(t_xk);

% empty matrix
mat_ind=zeros(n_k_x,length(t_yk));

% loop over observation times of x
%--------------------------------------------
for i=1:n_k_x 
   
    % length of overlap of return spells of x,y (else 0)
    mat_ind(i,:)=max(min(t_xk(i),t_yk)-max(tl_xk(i),tl_yk),0);
    
    
 end