function RCovSS=RCovSS(LogPrice,K)
%%  RCovSS
%--------------------------------------------------------------
% Subsampled Realized Covariance Estimator
%--------------------------------------------------------------
% INPUT:
% Log-Price -> (n x p) matrix of Log-Prices
% K -> number of subsamples: compute (rescaled) average of K RCovs on 
% frequency K based on shifting 1 observation for each Rcov estimate
%--------------------------------------------------------------
% OUTPUT:
% RCovSS -> subsampled (p x p) realized covariance estimate
% -------------------------------------------------------------------------
%
% Peter Malec, May 7, 2012
% -------------------------------------------------------------------------
%       
%% Compute Subsampled Realized Covariance

% compute Kth differences
Lret=LogPrice(K+1:end,:)-LogPrice(1:end-K,:);

% compute estimate
RCovSS=Lret'*Lret/K;