function RCovSS=RCovSS_loop(logPrice,K)
%%  RCovSS_loop
%--------------------------------------------------------------
% Subsampled Realized Covariance Estimator
%--------------------------------------------------------------
% INPUT:
% log-Price -> (n x p) matrix of Log-Prices
% K -> number of subsamples: compute (rescaled) average of K RCovs on 
% frequency K based on shifting 1 observation for each Rcov estimate
% Note: Computation based on loop
%--------------------------------------------------------------
% OUTPUT:
% RCovSS -> subsampled (p x p) realized covariance estimate
% -------------------------------------------------------------------------
%
% Peter Malec, May 8, 2012
% -------------------------------------------------------------------------
%       
%% Compute Subsampled Realized Covariance using loop

m = length(logPrice)-1;
RCovSS =zeros(size(logPrice,2),size(logPrice,2));

 for firstIndex=1:K
        returns = diff(logPrice(firstIndex:K:m,:));
        RCovSS = RCovSS+ returns'*returns;
 end

 RCovSS=RCovSS/K;
 



