function GammaH = AutoCovarianceRoel(rftdata, hval)
 % computes the Autocovariance matrices
 
 % Lada M Kyj
% March 10, 2010
% QPL Berlin
% lada.kyj@db.com
 
 % follows Andrews (1991)
 % inputs are Refresh time sampled data and optimal Hval
 % Roel's edit
[n p] = size(rftdata);                                                                                  %see formula in BNHLS(2008)(with my correction)
if hval > 0
    GammaH = rftdata(hval+1:end,:)'*rftdata(1:end-hval,:);
else
    GammaH = rftdata(1:end+hval,:)'*rftdata(1-hval:end,:);
end   