function [BNans]=MRK(RFTrtn,Hvalstar)
%Provides Multivariate Realized Kernel Estimates following BNHLS(2011)

% Peter Malec
% July 29, 2011

%INPUTS:
%%%%%%%%
% RFTrtn >>> matrix of log-returns based on synchronized price data using
% refresg time sampling
% Hvalstar >>> Bandwidth

%INPUTS:
%%%%%%%%
% BNans >>> Multivariate realized kernel estimate

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[n,p]=size(RFTrtn);

% initialize space for MRK matrices
BNans = zeros(p,p);


%Compute MRK estimates
for i = -(round(Hvalstar)+1):(round(Hvalstar)+1)                    %bandwidth has to be rounded(nearest integer)>>>why +1?>k(x)=0 for x>=1>but round(H) ~= H (general)>>otherwise we could drop +1>>
    kernw = ParzenKernel(abs(i)/(Hvalstar+1));                                                                                                                  %But: irrelevant for H=0>>here k(H+1/H+1)=k(1)=0>>RK=RV (RFTS)                                          
    autocov = AutoCovarianceRoel(RFTrtn, i);            %absolute value of i(h)>kernel not defined at zero
    BNans = BNans + kernw*autocov;
end