function [nts]=comp_nts_per_obs(inpath,inpathrv,inpathnoise,ticker,tdate,sourced,typed,cl_ind,rev_ind,freqrv,nss,Q_max,alpha,skips)
%% comp_nts_per_obs
%------------------------------------------------------------------
% compute noise-to-signal-ratio per obs following Oomen (2006)
%---------------------------------------------------------
%
%% Preparations

% clean?
if cl_ind==1
    cl_str='cl';            % cleaning string for output file
else
    cl_str='ncl';
end

% revisions?
if rev_ind==1
     rev_str='_rev';            
else
     rev_str='';     
end
% -------------------------------------------------------------------------
%
%% number of obs

% load data
name_temp=strcat(inpath,ticker,filesep,ticker,'_',datestr(tdate,'yyyymmdd'),'_',typed,'_',cl_str,'.mat');

% index for existence
index=isequal(exist(name_temp,'file'),2);

if isequal(index,1)

    load(name_temp);
    if isequal(typed,'trades')
        midprice=trades;
    end
    if rev_ind==1
        midprice=keep_rev(midprice,2);
    end
    
    % compute n obs
    n_obs=size(midprice,1);
    
else
    
    n_obs=NaN;
    
end
% -------------------------------------------------------------------------
%
%% Noise

% check for existence of file
if Q_max>1
    % alpha_label
    alpha_l=num2str(alpha);
    alpha_l(alpha_l=='.')='';
   if ~isempty(skips)
       name3=strcat(inpathnoise,ticker,filesep,'noise_est_',ticker,'_',sourced,'_',datestr(tdate,'yyyymmdd'),typed,cl_str,rev_str,'_alpha',alpha_l,'_Q',int2str(Q_max),'_ss',int2str(skips),'.mat');
    else
        name3=strcat(inpathnoise,ticker,filesep,'noise_est_',ticker,'_',sourced,'_',datestr(tdate,'yyyymmdd'),typed,cl_str,rev_str,'_alpha',alpha_l,'_Q',int2str(Q_max),'.mat');
    end
else
     name3=strcat(inpathnoise,ticker,filesep,'noise_est_',ticker,'_',sourced,'_',datestr(tdate,'yyyymmdd'),typed,cl_str,rev_str,'.mat');
end
index3=isequal(exist(name3,'file'),2);
    
if index3
%---------------------------------------------------------
    indat=iload(name3,'eta_est');
    noisev=indat.eta_est;
    if noisev<=0
          noisev=eps;
    end
else
    noisev=NaN;
end
% -------------------------------------------------------------------------
%
%% Obtain subsampled rv estimates

% check for existence of file
if ~isempty(nss)
    name5=strcat(inpathrv,'rv_',sourced,'_',ticker,'_',datestr(tdate,'yyyymmdd'),typed,'_',cl_str,rev_str,...
                '_freq',int2str(freqrv),'_nss',int2str(nss),'.mat');
else
    name5=strcat(inpathrv,'rv_',sourced,'_',ticker,'_',datestr(tdate,'yyyymmdd'),typed,'_',cl_str,rev_str,...
                '_freq',int2str(freqrv),'.mat');
end
index5=isequal(exist(name5,'file'),2);
    
if index5
%---------------------------------------------------------
    indat=iload(name5,'rvest');
    rvSS=indat.rvest.rvSS;
else
    rvSS=NaN;
end
% -------------------------------------------------------------------------
%
%% Compute Noise-To-Signal per Obs

nts=sqrt(n_obs*(noisev/rvSS));







