function BiaNg = BiaNg2002_svd(covariance,maxM,Tval, k)
%BiaNg2002.m
%%%%%%%%%%%%%%%%%
%INPUTS%%%%%%%
%%%%%%%%%%%%%%%%%%%%%
%covariance >> we need to assume that endog variables of PCA have zero mean
%>>> note: computed eigenvalues are variances of factors, transpose of
%eigenvector matrix contains loading
%maxM >> maximum number of factors (cap K in formula)
%Tval >> number of obs (T in formula)
%k >> number of dimensions (p in formula)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%


% Stuff Max number of factors

[U,S,V] = svds(covariance,maxM);                %conduct eigenvalue decomp (actually singular value decomp) of covariance matrix

Sigma2M = mean(diag(covariance-U*S*V'));        %compute cov matrix of errors as diff between observed cov matrix and cov matrix predicted by factors (for max number of factors)
                                                                                                        %>>>estimate sigma^2(K) from formula by averaging over est variances of the individual errors

                                                                                                        
BiaNg = NaN*zeros(maxM, 2);                                                 %empty matrix for biaNg criterion for every number of factors>>2 columns (2 indicators)
for m = 1:maxM
    [U,S,V] = svds(covariance,m);                                           % svd for m factors
    BiaNg(m,1) = mean(diag(covariance-U*S*V')) + m*Sigma2M*((k+Tval)/(k*Tval))*log((k*Tval)/(k+Tval));          % biaNg1 for m factors (sigma^2(k) from formula estimated as for max number of factors above)
    BiaNg(m,2) = mean(diag(covariance-U*S*V')) + m*Sigma2M*((k+Tval)/(k*Tval))*log((min(sqrt(k),sqrt(Tval)))^2); % biaNg2 for m factors (sigma^2(k) from formula estimated as for max number of factors above)
end
