function Cor_make=CorrelationMaker(valuesIn,vectorsIn, pCol, nof)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Computes Correlation Matrix using the first nof factors
%INPUTS:
%valuesln>>     vector of eigenvalues sorted by size and total variations
%vectorsln>>> array of eigenvectors sorted as above >>rows of the matrix are put in rows of
%the array (eigenvector matrix stacked)
%pCOL>>>    columns of the covariance matrix
%nof>>>    # of factors
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[n p] = size(valuesIn);

Cor_for = zeros(n, pCol, pCol);         %empty correlation matrix for each obs

%compute correlation matrix for each obs
for j=1:n                 %'reverse' spectral decomposition with nof vectors,  NOTE: reshape command produces TRANSPOSE of eigenvector matrix (eigenvec in rows not cols)
     temp = reshape(vectorsIn(j,1:nof,1:pCol),nof,pCol)'*diag(valuesIn(j,1:nof))*reshape(vectorsIn(j,1:nof,1:pCol),nof,pCol);
     temp(logical(eye(pCol))) = ones(1,pCol);   %put ones on the main diagonal of the corr matrix (correction of the reverse decomposition)>>like adding estimates of idiosyncratic variances (true - model estimates)
     Cor_make(j,:,:) = temp;
end