function Covmat_Fact=cov_fac_biang(covariance,maxM,Tval, k)
%% cov_fac_biang
%---------------------------------------------------------
% Factor Covariance Matrix with no of factors 
% chosen based on BiaNG(2002) criterion
%---------------------------------------------------------
%INPUTS
%maxM -> maximum number of factors (cap K in formula)
%Tval -> number of obs (T in formula)
%k  -> number of dimensions (p in formula)
%INPUTS
% -> factor covariance matrix
%-----------------------------------------------------------
%
%% Create Factor Covariance Matrix

% create (maxM x 2) matrix of values of criteria
BiaNg = BiaNg2002_svd(covariance,maxM,Tval, k);

% minimum value of 2 criteria for no of factors
 temp =min(BiaNg,[],2);
 
 % optimal number of factors
 BiaNg_opt = find((temp-min(temp))==0);
 
 %compute factor covariance
 [Covmat_Fact, ~]=reg_fac_structure_cov_f(covariance, BiaNg_opt);