function x=exog_noise_ar1(y,eta,rho_u)
%% exog_noise_ar1
%--------------------------------------------------------------
% Adds exogenous iid or ar(1) noise to 
%efficient prices 
%--------------------------------------------------------------
% INPUT:
% Y  -> vector of efficient prices
% eta -> noise variance or LR noise variance (if AR(1))
% rho_u -> 1st order autocorrelation of noise process (=AR par)
%--------------------------------------------------------------
% OUTPUT:
% x -> vector of noise dilluted prices
% -------------------------------------------------------------------------
%
% Peter Malec, April 22, 2014
% -------------------------------------------------------------------------
%   
%% Add simulated noise

% simulate noise
if (nargin<3)||isempty(rho_u)
    u=randn(length(y),1)*sqrt(eta);
else
    u=filter(1,[1 (-rho_u)],randn(length(y),1)*sqrt(eta*(1-rho_u)^2));
end
    
% Add noise
x=y+u;



