function x=exog_noise_autocorr(y,omega2,rho_u)
%% endog_noise
%--------------------------------------------------------------
% Adds endogenous iid or AR(1) noise to 
%efficient prices following approach by Barndorff-Nielsen et al. (JE, 2011)
%--------------------------------------------------------------
% INPUT:
% Y  -> vector of efficient prices
% omega2 -> noise variance
% rho_u -> 1st order autocorrelation of noise process
%               (in tick time)
%--------------------------------------------------------------
% OUTPUT:
% x -> vector of noise dilluted prices
% -------------------------------------------------------------------------
%
% Peter Malec, October 25, 2012
% -------------------------------------------------------------------------
%   
%% Add simulated noise

% simulate noise
if isequal(rho_u,0)
    u=randn(length(y),1)*sqrt(omega2);
else
    u=filter(1,[1 (-rho_u)],randn(length(y),1)*sqrt(omega2));
end
    
% Add noise
x=y+u;



