function x=exog_noise_ma(y,eta,theta)
%% exog_noise_ma
%--------------------------------------------------------------
% Adds exogenous iid or ma(q) noise to 
%efficient prices 
%--------------------------------------------------------------
% INPUT:
% Y  -> vector of efficient prices
% eta -> noise variance or LR noise variance (if MA(q))
% theta -> vector of Ma parameters
%--------------------------------------------------------------
% OUTPUT:
% x -> vector of noise dilluted prices
% -------------------------------------------------------------------------
%
% Peter Malec, April 9, 2014
% -------------------------------------------------------------------------
%   
%% Add simulated noise

% simulate noise
if (nargin<3)||isempty(theta)
    u=randn(length(y),1)*sqrt(eta);
else
    u=sim_maq(length(y),theta,sqrt(eta)/(1+sum(theta)));
end
    
% Add noise
x=y+u;



