function E_sigma4=exp_sigma4(t,gamma0,alpha,beta0,beta1)
%% sim_poisson
%--------------------------------------------------------------
% Computes expecation of spot volatilities^4 if log-volatilities
% follow on OU process
%--------------------------------------------------------------
% INPUT:
% t -> column vector of observation times
% gamma0 -> starting value of OU process
% alpha -> mean reversion parameter of OU process
% beta0,beta1 -> parameters used in exponential transformation of
% log-volatilites
%--------------------------------------------------------------
% OUTPUT:
% E_sigma4 -> column vector of expected spot volatilities^4 at times t
% -------------------------------------------------------------------------
%
% Peter Malec, May 9, 2012
%
% -------------------------------------------------------------------------
%       
%% Compute expectations

E_sigma4=4*beta0+4*beta1*exp(alpha*t)*gamma0+4*(beta1^2/alpha)...
*(exp(2*alpha*t)-1);
E_sigma4=exp(E_sigma4);