function s=s_exp(u,u0)
%% s_exp
% -------------------------------------------------------------------------
%
% Peter Malec, April 9, 2014
% -------------------------------------------------------------------------
%   
% -------------------------------------------------------------------------

% input check

if ~isequal(size(u,1),1)&&~isequal(size(u,2),1)
    error('u has to be vector!')
end

if ~isequal(size(u0,1),1)||~isequal(size(u0,2),1)
    error('u0 has to be scalar!')
end

% index for values below threshold
u_sm_ind=u<=u0;

% constants
c1=exp(u0)/sqrt(u0);
c2=u0-u0^2;

%compute function
s=u_sm_ind.*exp(u)+(1-u_sm_ind).*sqrt(c2+u.^2)*c1;