function eta=sim_maq(N,theta,omega)
%% sim_maq
%-----------------------------------------------------------
% simulate ma(q) process
%----------------------------------------------------------

% order of process
q=length(theta);

% simulate underlying WN process
eta_dist=omega*randn(N+q,1);

% initialize 
eta=NaN*zeros(N+q,1);

% set zeros as starting values (=E[eta_dist])
eta(1:q)=zeros(q,1);

% loop to simulate process
for i=(q+1):length(eta)
    eta(i)=eta_dist(i)+theta(:)'*flipud(eta_dist((i-q):(i-1)));
end

% drop starting values
eta=eta((q+1):end);