  function [rho_v] = rho_func_beta(y,b)
%% rho_func_beta
%--------------------------------------------------------------
% evaluates rho function for beta kernel by chen(2000)
%--------------------------------------------------------------
% INPUT:
% y -> point of estimation
% b  -> bandwidth
%--------------------------------------------------------------
% OUTPUT:
% rho_v - > value of rho function
% -------------------------------------------------------------------------
%
% Peter Malec, May 6, 2013
% -------------------------------------------------------------------------
%   
%% Rho function

% check point of estimation
if (y <0) || (y > 1)
    error('Point of estimation has to be between 0 and 1!')
end

% evaluate function
rho_v=2*b^2+2.5-sqrt(4*b^4+6*b^2+2.25-y.^2-y/b);

