function out_arr=ivech2d(in_mat,K)
%% ivech3
%---------------------------------------------------------
% create 2d array of (symmetric) KxK matrices 
%---------------------------------------------------------
% INPUT:
% in_mat -> (K(K+1)/2 x d2) matrix with disctinct elements of
%                   KxK matrices in 1st dimension
% K            -> dimension of matrix
%--------------------------------------------------------------
% OUTPUT:
% out_arr -> (KxK x d2) array of (symmetric) KxK matrices 
% -------------------------------------------------------------------------
%
% Peter Malec, April 29, 2016
%
% -------------------------------------------------------------------------
%       
%% Create array

% size of of array
[Ktot, d2]=size(in_mat);

% check dimension
if ~isequal(Ktot,K*(K+1)/2)
    error('First dimension must be K(K+1)/2 !')
end

% Initialize the output data
out_arr=zeros(K,K,d2);

% inverse vech for array
%----------------------------
pl=tril(ones(K));
pla =logical(pl(:,:,ones(d2,1)));
out_arr(pla)=in_mat;
id=eye(K);
ida=logical(id(:,:,ones(d2,1)));
diag_out_arr(ida)=out_arr(ida);
out_arr=out_arr+permute(out_arr,[2 1 3])-reshape(diag_out_arr,K,K,d2);


