function out_arr=ivech3(in_mat)
%% ivech3
%---------------------------------------------------------
% create array of (symmetric) 3x3 matrices 
%---------------------------------------------------------
% INPUT:
% in_mat -> (6 x J) matrix with disctinct elements of 3x3 matrices in cols
%--------------------------------------------------------------
% OUTPUT:
% out_arr -> (3x3xJ) array of (symmetric) 3x3 matrices 
% -------------------------------------------------------------------------
%
% Peter Malec, April 19, 2012
%
% -------------------------------------------------------------------------
%       
%% Create array

% % size of matrices
% K2=size(in_mat,1);
% K=(-1+sqrt(1+8*K2))/2;

% size of 3rd dimension of array
J= size(in_mat,2);

% Initialize the output data
out_arr=zeros(3,3,J);

% inverse vech for array
%----------------------------
pl=tril(ones(3));
pla =logical(pl(:,:,ones(J,1)));
out_arr(pla)=in_mat;
id=eye(3);
ida=logical(id(:,:,ones(J,1)));
diag_out_arr(ida)=out_arr(ida);
out_arr=out_arr+permute(out_arr,[2 1 3])-reshape(diag_out_arr,3,3,J);


