function [b,yhat]= ols(y,x,c)
%% ols
%--------------------------------------------------------------
% computes vector of ols estimates
%--------------------------------------------------------------
% INPUT:
% y -> (nx1) vector with obs of dependent variable
% x -> (nxk)  matrix containing observations of regressors
% c -> if >0, constant included
%--------------------------------------------------------------
% OUTPUT:
% b -> (kx1) vector of OLS estimates
% -------------------------------------------------------------------------
%
% Peter Malec, January 24, 2012
%
% Modification March 17, 2014
% provide fitted values
% -------------------------------------------------------------------------
%       
%%  Preparations

% Check c
if nargin==2
    c = 1;
end
if ~ismember(c,[0 1])
    error('C must be either 0 or 1.')
end

% include constant
if c
    x=[ones(size(x,1),1) x];
end

%%  Compute beta


b=x\y;

%%  Compute Fitted values

if nargout>1
    yhat=x*b;
end

