%% run_Noise_EST_CS_04032014.m
%--------------------------------------------------------------------------
% Estimate Long-Run Noise Variance and test for order of dependence
%--------------------------------------------------------------------------
%
%Peter Malec, March 4, 2014
%
% -------------------------------------------------------------------------
%
%% Define INPUTS


% Clear system
clear all;
clc;

% add procs
myaddToPath;

% Choose basepath
basepath =1;              

% source of data
source_d='LOBSTER';           % UPPER CASE!

% Stock
ticker_a      ={'AAPL','MSFT','GOOG','CSCO','ORCL','INTC','QCOM','AMGN','TEVA','GILD','AMZN','EBAY','NWSA',...
    'DTV','CELG','INFY','YHOO','COST','SPLS','SBUX','ADP','ESRX','ADBE','FSLR','BIIB','SYMC','JNPR','BRCM','AMAT','CMCSA'}; % apr 13

% datatype
typed='midp';           % midp: midquotes, trad: trades

% dates (entire period or spec dates)
startd=datenum('1 may 10');
endd=datenum('30 apr 14');
tdate_v=[];
%tdate_v=[datenum('29 apr 13'):datenum('30 apr 13')]';
%[datenum('1 apr 13'):datenum('5 apr 13') datenum('8 apr 13'):datenum('12 apr 13') datenum('22 apr 13') datenum('24 apr 13'):datenum('26 apr 13')]';

% start end end of trading (in hours)
startt=9.5;
endt=16;

%cleaning 
cl_ind=-1;           %if==1: cleaning is done

%revisions
rev_ind=-1;%1     %if ==1, only obs with price revisions are used

%sign level for test
alpha=0.05;

%maximum order of dependence
Q_max=25;%50;  %if Q_max=0: iid noise assumed

% skip sampling frequency in seconds 
skips=300;
% -------------------------------------------------------------------------
%
%% Determination of Basepath


if basepath ==1
    
    pathproject = '~//Projects//Spot_corr//MATLAB//';
    
elseif basepath ==2
    
    pathproject = '~//Spot_corr//MATLAB//';    
    
elseif basepath ==0
    
    pathproject = 'H:\\Spot_corr\\MATLAB\\';
    
elseif basepath ==-1
    
    pathproject = 'C:\\peter.malec\\Spot_corr\\MATLAB\\';            
    
    
elseif basepath ==-2
    
    pathproject = 'X:\\peter.malec\\Spot_corr\\MATLAB\\';            
    
else
    
    pathproject = 'H:\\Spot_corr\\MATLAB\\';
    
end
% -------------------------------------------------------------------------
%
%% Determination of In- and Outpath and Path for additional Data

inpath=strcat(pathproject,'Data',filesep,source_d,filesep,'Filtered',filesep);

addpath=strcat(pathproject,'Data',filesep,'Add',filesep);

outpath=strcat(pathproject,'Emp_AnA',filesep,'Estimates',filesep,'Noise_est',filesep);
% -------------------------------------------------------------------------
%
%% Load Vector of Trading Days

% Create vector of trading days in matlab date format
load(strcat(addpath,'trading_days_cl_',source_d,'_m32_20100501_20140430_thrq1500_thrtr800_tthrq300_tthrtr720_cl.mat'));
date_v=t_date_v_cl;
% -------------------------------------------------------------------------
%
%% Create Vectors of Asset Pairs and Estimate Spot Covariance Matrices and Correlations

% Create vector of trading days in matlab date format
if isempty(tdate_v)
    tdate_v=date_v(sort(find((date_v>=startd)&(date_v<=endd))));
end

%create vector of skip sampling information
skipv=[skips (endt-startt)];

%loop across asset pairs
%----------------------------------------------
for i=1:length(ticker_a)
    
    ticker=ticker_a{i};
    
    % loop over trading days
    %----------------------------------------------
    parfor j=1:length(tdate_v)
        % select date and display
        tdate=tdate_v(j);
        disp([ticker ':' datestr(tdate,'yyyy--mm--dd')])
    
        if Q_max>1
            Noise_EST_proc(ticker,tdate,typed,cl_ind,rev_ind,alpha,Q_max,inpath,source_d,outpath,skipv);
        else
            Noise_EST_simp_proc(ticker,tdate,typed,cl_ind,rev_ind,inpath,source_d,outpath);
        end
   
    end

end







