%% run_comp_max_max_difft_05032014.m
%--------------------------------------------------------------------------
% Compute max of longest even duration across all stocks
%--------------------------------------------------------------------------
%
% Peter Malec, march 5, 2014
%
% -------------------------------------------------------------------------
%
%% Define INPUTS


% Clear system
clear all;
clc;

% add procs
myaddToPath;

% Choose basepath
basepath =-1;              

% source of data
source_d='LOBSTER';           % UPPER CASE!

% Stock
ticker_a      ={'AAPL','MSFT','GOOG','CSCO','ORCL','INTC','QCOM','AMGN','TEVA','GILD','AMZN','EBAY','NWSA',...
    'DTV','CELG','INFY','YHOO','COST','SPLS','SBUX','ADP','ESRX','ADBE','FSLR','BIIB','SYMC','JNPR','BRCM','AMAT','CMCSA','SPY','QQQ'}; % apr 13

% datatype
typed='midp';           % midp: midquotes, trad: trades

% dates (entire period or spec dates)
startd=datenum('1 may 10');
endd=datenum('31 dec 13');
tdate_v=[];
%tdate_v=[datenum('29 apr 13'):datenum('30 apr 13')]';
%[datenum('1 apr 13'):datenum('5 apr 13') datenum('8 apr 13'):datenum('12 apr 13') datenum('22 apr 13') datenum('24 apr 13'):datenum('26 apr 13')]';

%cleaning 
cl_ind=1;           %if==1: cleaning is done

%revisions
rev_ind=-1;     %if ==1, only obs with price revisions are used
% -------------------------------------------------------------------------
%
%% Determination of Basepath


if basepath ==1
    
    pathproject = 'D:\\Spot_corr\\MATLAB\\';
    
elseif basepath ==2
    
    pathproject = 'D:\\WORK\\Spot_corr\\MATLAB\\';    
    
elseif basepath ==0
    
    pathproject = 'H:\\Spot_corr\\MATLAB\\';
    
elseif basepath ==-1
    
    pathproject = 'C:\\peter.malec\\Spot_corr\\MATLAB\\';            
    
    
elseif basepath ==-2
    
    pathproject = 'X:\\peter.malec\\Spot_corr\\MATLAB\\';            
    
else
    
    pathproject = 'H:\\Spot_corr\\MATLAB\\';
    
end
% -------------------------------------------------------------------------
%
%% Determination of In- and Outpath and Path for additional Data

inpath=strcat(pathproject,'Data\\',source_d,'\\Filtered\\');

addpath=strcat(pathproject,'Data\\Add\\');

outpath=strcat(pathproject,'Emp_AnA\Estimates\\Add\\Max_tdiff_LOBSTER\\');
% -------------------------------------------------------------------------
%
%% Load Vector of Trading Days

% Create vector of trading days in matlab date format
load(strcat(addpath,'trading_days.mat')); 
% -------------------------------------------------------------------------
%
%% Preparations

% clean?
if cl_ind==1
    cl_str='cl';            % cleaning string for output file
else
    cl_str='ncl';
end

% revisions?
if rev_ind==1
     rev_str='_rev';            
else
     rev_str='';     
end
% -------------------------------------------------------------------------
%
%% Check Number of Observations

% no stocks
m=length(ticker_a);

% Create vector of trading days in matlab date format
if isempty(tdate_v)
    tdate_v=date_v(sort(find((date_v>=startd)&(date_v<=endd))));
end

% loop over trading days
%----------------------------------------------
for j=1:length(tdate_v)
    
    % select date and display
    tdate=tdate_v(j);
    disp(datestr(tdate,'yyyy--mm--dd'))
    
    %empty vector
    max_difft_vec=NaN*zeros(m,1);

    %loop across asset pairs
   parfor i=1:m
    
        max_difft_vec(i)=comp_max_difft(inpath,ticker_a{i},tdate,typed,cl_str,rev_ind);
   
   end
   
   %max
   max_max_difft=max(max_difft_vec);
   
   % display
    display(['Maximum duration: ' int2str(max_max_difft)]);   
    
    %save 
    name_out=strcat(outpath,'m',int2str(m),'_',datestr(tdate,'yyyymmdd'),'_',typed,'_',cl_str,rev_str,'.mat');
    save(name_out,'max_max_difft')

end








