%% run_plot_price_event_12052014.m
%--------------------------------------------------------------------------
% plots intraday price path of specific asset together with vertical lines
% indicating events
%--------------------------------------------------------------------------
%
% Peter Malec, May 12, 2014
%
% -------------------------------------------------------------------------
%
%% Define INPUTS


% Clear system
clear all;
clc;

% add procs
myaddToPath;

% Choose basepath
basepath =1;              

% source of data
source_d='LOBSTER';           % UPPER CASE!

% Stock
ticker      ='AAPL';

% datatype
typed='joint';           % midp: midquotes, trad: trades, joint: combined

% dates (entire period or spec dates)
tdate=datenum('6 may 10');

% start end end of trading (in hours)
startt=9.5;
endt=16;

%cleaning 
cl_ind=-1;           %if==1: cleaning is done
%revisions
rev_ind=-1;     %if ==1, only obs with price revisions are used

% if typed='joint'
cl_indq=-1;           %if==1: cleaning is done
cl_indtr=-1;           %if==1: cleaning is done
rev_indq=-1;     %if ==1, only obs with price revisions are used
rev_indtr=-1;     %if ==1, only obs with price revisions are used

% time focus (from to )
foc_time=[];%[datenum('15:30') datenum('16:00')];

% time of vertline
vertt=[datenum('14:00')];   % in format HH:MM:ss: if empty: no vertical line 
                        
% annotations  (all following expr need to have same dimemsion)
text_pos_x=[datenum('14:00') datenum('14:35') datenum('14:37') datenum('14:46:11') datenum('15:01')];                   %different positions possible (empty if no labels)
halign_a={'left','right','right','left','right'};           % horizontal alignment of text (left or right)
long_ind_v=[1 1 0 1 1];                   % indicator for long arrow-> arrows need same dir as above.
add_v=[0.5 -3 -3 0.5 -3]*0.00125;                           % correction (inr: 0.00125) for position of labels (positive if left, otherwise negative)
% tdate=datenum('6 may 10');
% no foc
% text_pos_x=[datenum('14:00') datenum('14:35') datenum('14:37') datenum('14:46:11') datenum('15:01')];                   %different positions possible (empty if no labels)
% halign_a={'left','right','right','left','right'};           % horizontal alignment of text (left or right)
% long_ind_v=[1 1 0 1 1];                   % indicator for long arrow-> arrows need same dir as above.
% add_v=[0.5 -3 -3 0.5 -3]*0.00125;                           % correction (inr: 0.00125) for position of labels (positive if left, otherwise negative)
% foc
% text_pos_x=[datenum('14:00') datenum('14:35') datenum('14:37') datenum('14:46:11') datenum('15:01')];                   %different positions possible (empty if no labels)
% halign_a={'left','left','right','left','right'};           % horizontal alignment of text (left or right)
% long_ind_v=[1 0 0 1 1];                   % indicator for long arrow-> arrows need same dir as above.
% add_v=[0 -0.4 -1.3 0 -1.3]*0.00125;                           % correction (inr: 0.00125) for position of labels (positive if left,
%tdate=datenum('27 dec 12');
% text_pos_x=[datenum('10:00') datenum('14:20')];                   %different positions possible (empty if no labels)
% halign_a={'left','left'};           % horizontal alignment of text (left or right)
% long_ind_v=[1 1];                   % indicator for long arrow-> arrows need same dir as above.
% add_v=[1 1]*0.00125;                           % correction (inr: 0.00125) for position of labels (positive if left, otherwise negative)
% tdate=datenum('25 jan 13');
% no foc
% text_pos_x=[datenum('15:59')];                   %different positions possible (empty if no labels)
% halign_a={'right'};           % horizontal alignment of text (left or right)
% long_ind_v=[1];                   % indicator for long arrow-> arrows need same dir as above.
% add_v=[-3.5]*0.00125;                           % correction (inr: 0.00125) for position of labels (positive if left, otherwise ne
% foc
% text_pos_x=[datenum('15:59')];                   %different positions possible (empty if no labels)
% halign_a={'right'};           % horizontal alignment of text (left or right)
% long_ind_v=[1];                   % indicator for long arrow-> arrows need same dir as above.
% add_v=[-1]*0.00125;                           % correction (inr: 0.00125) for position of labels (positive if left, otherwise negative)
% tdate=datenum('23 apr 13');
% no foc
% text_pos_x=[datenum('13:07') datenum('13:10') datenum('13:14')];                   %different positions possible (empty if no labels)
% halign_a={'right','right','right'};           % horizontal alignment of text (left or right)
% long_ind_v=[1 1 1];                   % indicator for long arrow-> arrows need same dir as above.
% add_v=[-3.5 -3.5 -3.5]*0.00125;                           % correction (inr: 0.00125) for position of labels (positive if left, otherwise negative)
%  foc
% text_pos_x=[datenum('13:07') datenum('13:10') datenum('13:14')];                   %different positions possible (empty if no labels)
% halign_a={'left','left','right'};           % horizontal alignment of text (left or right)
% long_ind_v=[1 1 1];                   % indicator for long arrow-> arrows need same dir as above.
% add_v=[0 0 -0.3]*0.00125;                           % correction (inr: 0.00125) for position of labels (positive if left, otherwise negative)
% -------------------------------------------------------------------------
%
%% Determination of Basepath


if basepath ==1
    
    pathproject = '~//Projects//Spot_corr//MATLAB//';
    
elseif basepath ==2
    
    pathproject = '~//Spot_corr//MATLAB//';    
    
elseif basepath ==0
    
    pathproject = 'H:\\Spot_corr\\MATLAB\\';
    
elseif basepath ==-1
    
    pathproject = 'C:\\peter.malec\\Spot_corr\\MATLAB\\';            
    
    
elseif basepath ==-2
    
    pathproject = 'X:\\peter.malec\\Spot_corr\\MATLAB\\';            
    
else
    
    pathproject = 'H:\\Spot_corr\\MATLAB\\';
    
end
% -------------------------------------------------------------------------
%
%% Determination of In- and Outpath and Path for additional Data

inpath=strcat(pathproject,'Data',filesep,source_d,filesep,'Filtered',filesep);

addpath=strcat(pathproject,'Data',filesep,'Add',filesep);

outpath=strcat(pathproject,'Emp_AnA',filesep,'Plots',filesep);
% -------------------------------------------------------------------------
%
%% Either Quotes or Trades

if ~isequal(typed,'joint')
    
    % clean?
if cl_ind==1
     cl_str='cl';            % cleaning string for output file
else
     cl_str='ncl';
end

% revisions?
if rev_ind==1
     rev_str='_rev';            
else
     rev_str='';     
end

% check existence of data
name=strcat(inpath,ticker,filesep,ticker,'_',datestr(tdate,'yyyymmdd'),'_',typed,'_',cl_str,'.mat');
index=isequal(exist(name,'file'),2);

if index
%---------------------------------------------------------

% load data
load(name);
if isequal(typed,'trades')
   midprice=trades;
end
if rev_ind==1
   midprice=keep_rev(midprice,2);
end
% -------------------------------------------------------------------------
%   
%% Plot

%ylabel
if isequal(typed,'trades')
    ylabs='Transaction Price';
elseif isequal(typed,'midp')
    ylabs='Mid-Quote';
end

% normalize times
times_n=midprice(:,1)/(24*3600);   

% create vector of labels
if ~isempty(text_pos_x)
    if (length(text_pos_x)~=length(halign_a))||(length(text_pos_x)~=length(long_ind_v))||...
            (length(long_ind_v)~=length(halign_a))
        error('text_pos_x, long_ind_v and halign_a must have same length!')
    end
    text_a=cell(length(text_pos_x),1);
    for i=1:length(text_a)
        base_str=strcat('$', int2str(i),')$');
        if ~isequal(long_ind_v(i),1)
            l_str='';
        else
            l_str='long';
        end
        if isequal(halign_a{i},'left')
            text_a{i}=strcat('$\',l_str,'leftarrow\left(', int2str(i),'\right)$');
        else
           text_a{i}=strcat('$\left(', int2str(i),'\right)\',l_str,'rightarrow$');
        end
    end
else
    text_a=cell(length(text_pos_x),1);
end

% plot
%-----------------------------
fh=figure;
 
set(fh, 'color', 'white');

h=plot(times_n,midprice(:,2));

if isequal(typed,'trades')
    set(h(1),'LineStyle','none','Marker','*','MarkerFaceColor',rgb('darkblue'),'MarkerEdgeColor',rgb('darkblue'),'MarkerSize',1.3);
else
    set(h(1),'color',rgb('darkblue'),'linestyle','-','linewidth',1.3);
end

xl = xlabel('\bfseries Time of Day');
yl = ylabel(['\bfseries ' ylabs]);
    
set(gca, 'TickDir', 'in', 'Box', 'off' ,'XMinorTick','Off','YMinorTick','Off','linewidth',1.5,'Xgrid','on','Ygrid','on'); % here gca means get current axis
    
set(xl,'interpreter','latex','FontSize',8);
set(yl,'interpreter','latex','FontSize',8);

if ~isempty(foc_time)
    foc_time_adj=foc_time-datenum('00:00');
    set(gca,'XLim',foc_time_adj)
    % tick labels
    xtdata_num=linspace(foc_time_adj(1),foc_time_adj(2),4);
    xtdata_str=datestr(xtdata_num,'HH:MM');
    set(gca,'XTickLabel',xtdata_str)
    foc_timel='_foct';
    datetick('x','HH:MM','keeplimits');
else
    datetick('x','HH:MM');
    set(gca,'XLim',[9.5/24 16/24])
     set(gca,'XTick',(9:1:16)/24)
    foc_timel='';
end

ytickv = get(gca,'YTick');
set(gca,'YTick',linspace(ytickv(1),ytickv(end),5));

parent = get(h(1),'Parent');
set(parent,'FontSize',9,'FontWeight','demi');    

%# vertical line
if ~isempty(vertt)
    gridxy(vertt-datenum('00:00'), 'LineStyle','--', 'Color',rgb('black'),'linewidth',1.3)
end

%text
if sum(cellfun(@isempty,text_a))<length(text_a)
    for i=1:length(text_a)
        x_pos=text_pos_x(i)-datenum('00:00');
        y_pos=midprice(find(times_n>=x_pos,1,'first'),2);
                 text(x_pos+add_v(i),y_pos,text_a{i},...
         'HorizontalAlignment',halign_a{i},'interpreter','latex','FontSize',10)
    end
end

% label vert
if ~isempty(vertt)
      vertl='_vl';
else
      vertl='';
end

% label vert
if sum(cellfun(@isempty,text_a))<length(text_a)
      textl='_tt';
else
      textl='';
end

% save plot
nameout=strcat(outpath,'price_',ticker,'_',source_d,'_',datestr(tdate,'yyyymmdd'),typed,'_',cl_str,rev_str,vertl,textl, foc_timel);

export_fig(nameout,'-pdf','-png');

% -------------------------------------------------------------------------
%   
else
    error('Data does not exist for chosen day!!!')
end

% -------------------------------------------------------------------------
%   
%% Quotes and Trades
else
    
% clean?
if cl_indtr==1
     cl_strtr='cl';            % cleaning string for output file
else
     cl_strtr='ncl';
end
if cl_indq==1
     cl_strq='cl';            % cleaning string for output file
else
     cl_strq='ncl';
end

% revisions?
if rev_indtr==1
     rev_strtr='_rev';            
else
     rev_strtr='';     
end
if rev_indq==1
     rev_strq='_rev';            
else
     rev_strq='';     
end

% check existence of data
nameq=strcat(inpath,ticker,filesep,ticker,'_',datestr(tdate,'yyyymmdd'),'_midp_',cl_strq,'.mat');
indexq=isequal(exist(nameq,'file'),2);
nametr=strcat(inpath,ticker,filesep,ticker,'_',datestr(tdate,'yyyymmdd'),'_trades_',cl_strtr,'.mat');
indextr=isequal(exist(nametr,'file'),2);

if logical(indexq*indextr)
%---------------------------------------------------------

% load data
load(nameq);
if rev_indq==1
   midprice=keep_rev(midprice,2);
end
load(nametr);
if rev_indtr==1
  trades=keep_rev(trades,2);
end
% -------------------------------------------------------------------------
%
%% select midquote just before trade

% how many trades
ntr=size(trades,1);

% vector for selected quotes
quotes_sel=NaN(ntr,1);

% check if there's quote before 1st trade
if midprice(1,1)>trades(1,1)
    midprice=[midprice(1,:);midprice];
    disp('Add 1st quotes at beginning of trading day!!!')
end

%loop
for i=1:ntr
    indv=find(midprice(:,1)<=trades(i,1),1,'last');
    quotes_sel(i)= midprice(indv,2);
end
% -------------------------------------------------------------------------
%   
%% Plot

%ylabel
ylabs='Price';

% normalize times
times_n=trades(:,1)/(24*3600);   

% create vector of labels
if ~isempty(text_pos_x)
    if (length(text_pos_x)~=length(halign_a))||(length(text_pos_x)~=length(long_ind_v))||...
            (length(long_ind_v)~=length(halign_a))
        error('text_pos_x, long_ind_v and halign_a must have same length!')
    end
    text_a=cell(length(text_pos_x),1);
    for i=1:length(text_a)
        base_str=strcat('$', int2str(i),')$');
        if ~isequal(long_ind_v(i),1)
            l_str='';
        else
            l_str='long';
        end
        if isequal(halign_a{i},'left')
            text_a{i}=strcat('$\',l_str,'leftarrow\left(', int2str(i),'\right)$');
        else
           text_a{i}=strcat('$\left(', int2str(i),'\right)\',l_str,'rightarrow$');
        end
    end
else
    text_a=cell(length(text_pos_x),1);
end

% plot
%-----------------------------
fh=figure;
 
set(fh, 'color', 'white');

h=plot(times_n,[trades(:,2) quotes_sel]);


set(h(1),'LineStyle','none','Marker','*','MarkerFaceColor',rgb('darkblue'),'MarkerEdgeColor',rgb('darkblue'),'MarkerSize',1.3);
set(h(2),'color',rgb('darkred'),'linestyle','-','linewidth',1.3);

l = legend({'Trades';'Mid-Quotes'});
               
xl = xlabel('\bfseries Time of Day');
yl = ylabel(['\bfseries ' ylabs]);
    
set(gca, 'TickDir', 'in', 'Box', 'off' ,'XMinorTick','Off','YMinorTick','Off','linewidth',1.5,'Xgrid','on','Ygrid','on'); % here gca means get current axis
    
set(xl,'interpreter','latex','FontSize',8);
set(yl,'interpreter','latex','FontSize',8);

set(l,'interpreter','latex','FontSize',8);
set(l,'Location','North','Orientation','horizontal','box','off')

if ~isempty(foc_time)
    foc_time_adj=foc_time-datenum('00:00');
    set(gca,'XLim',foc_time_adj)
    % tick labels
    xtdata_num=linspace(foc_time_adj(1),foc_time_adj(2),4);
    xtdata_str=datestr(xtdata_num,'HH:MM');
    set(gca,'XTickLabel',xtdata_str)
    foc_timel='_foct';
    datetick('x','HH:MM','keeplimits');
else
    datetick('x','HH:MM');
    set(gca,'XLim',[9.5/24 16/24])
     set(gca,'XTick',(9:1:16)/24)
    foc_timel='';
end


ytickv = get(gca,'YTick');
set(gca,'YTick',linspace(ytickv(1),ytickv(end),5));

parent = get(h(1),'Parent');
set(parent,'FontSize',9,'FontWeight','demi');    

%# vertical line
if ~isempty(vertt)
    gridxy(vertt-datenum('00:00'), 'LineStyle','--', 'Color',rgb('black'),'linewidth',1.3)
end

%text
if sum(cellfun(@isempty,text_a))<length(text_a)
    for i=1:length(text_a)
        x_pos=text_pos_x(i)-datenum('00:00');
        y_pos=midprice(find(times_n>=x_pos,1,'first'),2);
                 text(x_pos+add_v(i),y_pos,text_a{i},...
         'HorizontalAlignment',halign_a{i},'interpreter','latex','FontSize',10)
    end
end

% label vert
if ~isempty(vertt)
      vertl='_vl';
else
      vertl='';
end

% label vert
if sum(cellfun(@isempty,text_a))<length(text_a)
      textl='_tt';
else
      textl='';
end

% save plot
nameout=strcat(outpath,'price_',ticker,'_',source_d,'_',datestr(tdate,'yyyymmdd'),'joint_',cl_strq,cl_strtr,rev_strq,rev_strtr,vertl,textl,foc_timel);

export_fig(nameout,'-pdf','-png');

% 
% -------------------------------------------------------------------------
%   
else
    error('Data does not exist for chosen day!!!')
end


end


