%% run_plot_price_event_biv_04092016.m
%--------------------------------------------------------------------------
% plots intraday mid-quote path of 2 assets together with vertical lines
% indicating events
%--------------------------------------------------------------------------
%
% Peter Malec, September 4, 2016
%
% -------------------------------------------------------------------------
%
%% Define INPUTS


% Clear system
clear all;
clc;

% add procs
myaddToPath;

% Choose basepath
basepath =1;              

% source of data
source_d='LOBSTER';           % UPPER CASE!

% Stock
ticker_a      ={'AAPL','AMZN'}; % apr 13

% datatype
typed='quotes';           % midp: midquotes, quotes, trad: trades

% dates (entire period or spec dates)
tdate=datenum('23 apr 13');

% start end end of trading (in hours)
startt=9.5;
endt=16;

%cleaning 
cl_ind=-1;           %if==1: cleaning is done

%revisions
rev_ind=-1;     %if ==1, only obs with price revisions are used

% time focus (from to )
foc_time=[datenum('13:11:00') datenum('13:11:10')];%[datenum('13:30') datenum('16:00')];

% time of vertline
vertt=[datenum('13:07')];   % in format HH:MM:ss: if empty: no vertical line 

% time in seconds
useTimeSec=true;

% pre-specified y limits for comparison
comp_ylim=[401,405;265,269];

% tdate=datenum('6 may 10');
% no foc
% text_pos_x=[datenum('14:00') datenum('14:35') datenum('14:37') datenum('14:46:11') datenum('15:01')];                   %different positions possible (empty if no labels)
% halign_a={'left','right','right','left','right'};           % horizontal alignment of text (left or right)
% long_ind_v=[1 1 0 1 1];                   % indicator for long arrow-> arrows need same dir as above.
% add_v=[0.5 -3 -3 0.5 -3]*0.00125;                           % correction (inr: 0.00125) for position of labels (positive if left, otherwise negative)
% foc
% text_pos_x=[datenum('14:00') datenum('14:35') datenum('14:37') datenum('14:46:11') datenum('15:01')];                   %different positions possible (empty if no labels)
% halign_a={'left','left','right','left','right'};           % horizontal alignment of text (left or right)
% long_ind_v=[1 0 0 1 1];                   % indicator for long arrow-> arrows need same dir as above.
% add_v=[0 -0.4 -1.3 0 -1.3]*0.00125;                           % correction (inr: 0.00125) for position of labels (positive if left,
%tdate=datenum('27 dec 12');
% text_pos_x=[datenum('10:00') datenum('14:20')];                   %different positions possible (empty if no labels)
% halign_a={'left','left'};           % horizontal alignment of text (left or right)
% long_ind_v=[1 1];                   % indicator for long arrow-> arrows need same dir as above.
% add_v=[1 1]*0.00125;                           % correction (inr: 0.00125) for position of labels (positive if left, otherwise negative)
% tdate=datenum('25 jan 13');
% no foc
% text_pos_x=[datenum('15:59')];                   %different positions possible (empty if no labels)
% halign_a={'right'};           % horizontal alignment of text (left or right)
% long_ind_v=[1];                   % indicator for long arrow-> arrows need same dir as above.
% add_v=[-3.5]*0.00125;                           % correction (inr: 0.00125) for position of labels (positive if left, otherwise ne
% foc
% text_pos_x=[datenum('15:59')];                   %different positions possible (empty if no labels)
% halign_a={'right'};           % horizontal alignment of text (left or right)
% long_ind_v=[1];                   % indicator for long arrow-> arrows need same dir as above.
% add_v=[-1]*0.00125;                           % correction (inr: 0.00125) for position of labels (positive if left, otherwise negative)
% tdate=datenum('23 apr 13');
% no foc
% text_pos_x=[datenum('13:07') datenum('13:10') datenum('13:14')];                   %different positions possible (empty if no labels)
% halign_a={'right','right','right'};           % horizontal alignment of text (left or right)
% long_ind_v=[1 1 1];                   % indicator for long arrow-> arrows need same dir as above.
% add_v=[-3.5 -3.5 -3.5]*0.00125;                           % correction (inr: 0.00125) for position of labels (positive if left, otherwise negative)
%  foc
% text_pos_x=[datenum('13:07') datenum('13:10') datenum('13:14')];                   %different positions possible (empty if no labels)
% halign_a={'left','left','right'};           % horizontal alignment of text (left or right)
% long_ind_v=[1 1 1];                   % indicator for long arrow-> arrows need same dir as above.
% add_v=[0 0 -0.3]*0.00125;                           % correction (inr: 0.00125) for position of labels (positive if left, otherwise negative)
% -------------------------------------------------------------------------
%
%% Determination of Basepath


if basepath ==1
    
    pathproject = '~//Projects//Spot_corr//MATLAB//';
    
elseif basepath ==2
    
    pathproject = '~//Spot_corr//MATLAB//';    
    
elseif basepath ==0
    
    pathproject = 'H:\\Spot_corr\\MATLAB\\';
    
elseif basepath ==-1
    
    pathproject = 'C:\\peter.malec\\Spot_corr\\MATLAB\\';            
    
    
elseif basepath ==-2
    
    pathproject = 'X:\\peter.malec\\Spot_corr\\MATLAB\\';            
    
else
    
    pathproject = 'H:\\Spot_corr\\MATLAB\\';
    
end
% -------------------------------------------------------------------------
%
%% Determination of In- and Outpath and Path for additional Data

inpath=strcat(pathproject,'Data',filesep,source_d,filesep,'Filtered',filesep);

addpath=strcat(pathproject,'Data',filesep,'Add',filesep);

outpath=strcat(pathproject,'Emp_AnA',filesep,'Plots',filesep);
% -------------------------------------------------------------------------
%
%% Either Quotes or Trades
    
    % clean?
if cl_ind==1
     cl_str='cl';            % cleaning string for output file
else
     cl_str='ncl';
end

% revisions?
if rev_ind==1
     rev_str='_rev';            
else
     rev_str='';     
end

% check existence of data
name1=strcat(inpath,ticker_a{1},filesep,ticker_a{1},'_',datestr(tdate,'yyyymmdd'),'_',typed,'_',cl_str,'.mat');
index1=isequal(exist(name1,'file'),2);

name2=strcat(inpath,ticker_a{2},filesep,ticker_a{2},'_',datestr(tdate,'yyyymmdd'),'_',typed,'_',cl_str,'.mat');
index2=isequal(exist(name2,'file'),2);


if index1&&index2
%---------------------------------------------------------

% load data
load(name1);
if isequal(typed,'trades')
   midprice1=trades;
else
    midprice1=midprice;
end
if isequal(typed,'quotes')
    midprice1=[midprice1,0.5*(midprice1(:,2)+midprice1(:,3))];
end
if rev_ind==1
    if ~isequal(typed,'quotes')
        midprice1=keep_rev(midprice1,2);
    else
        midprice1=keep_rev(midprice1,4);
    end
end

load(name2);
if isequal(typed,'trades')
   midprice2=trades;
else
    midprice2=midprice;
end
if isequal(typed,'quotes')
    midprice2=[midprice2,0.5*(midprice2(:,2)+midprice2(:,3))];
end
if rev_ind==1
    if ~isequal(typed,'quotes')
        midprice2=keep_rev(midprice2,2);
    else
        midprice2=keep_rev(midprice2,4);
    end
end
% -------------------------------------------------------------------------
%   
%% Plot

%ylabel
if isequal(typed,'trades')
    ylabs='Transaction Price';
elseif isequal(typed,'midp')
    ylabs='Mid-Quote';
elseif isequal(typed,'quotes')
    ylabs='Quote';
end

% normalize times
times_n1=midprice1(:,1)/(24*3600);   
times_n2=midprice2(:,1)/(24*3600);   

% plot
%-----------------------------
fh=figure;
 
set(fh, 'color', 'white');

if ~isequal(typed,'quotes')
    [AX,h1,h2]=plotyy(times_n1,midprice1(:,2),times_n2,midprice2(:,2) );
    set(h1(1),'LineStyle','none','Marker','*','MarkerFaceColor',rgb('black'),'MarkerEdgeColor',rgb('black'),'MarkerSize',1.4);
    set(h2(1),'LineStyle','none','Marker','*','MarkerFaceColor',rgb('darkgrey'),'MarkerEdgeColor',rgb('darkgrey'),'MarkerSize',1.4);
else
    [AX,h1,h2]=plotyy(times_n1,midprice1(:,2:3),times_n2,midprice2(:,2:3) );
    set(h1(1),'LineStyle','none','Marker','o','MarkerFaceColor',rgb('black'),'MarkerEdgeColor',rgb('black'),'MarkerSize',2.8);
    set(h1(2),'LineStyle','none','Marker','+','MarkerFaceColor',rgb('black'),'MarkerEdgeColor',rgb('black'),'MarkerSize',3.8);
    set(h2(1),'LineStyle','none','Marker','o','MarkerFaceColor',rgb('darkgrey'),'MarkerEdgeColor',rgb('darkgrey'),'MarkerSize',2.8);
    set(h2(2),'LineStyle','none','Marker','+','MarkerFaceColor',rgb('darkgrey'),'MarkerEdgeColor',rgb('darkgrey'),'MarkerSize',3.8);
end

set(get(AX(1),'Xlabel'),'String','\bfseries Time of Day') 

set(AX(1),'XColor',rgb('black'),'YColor',rgb('black'));
set(AX(2),'XColor',rgb('black'),'YColor',rgb('black'));
               
set(get(AX(1),'Ylabel'),'String',['\bfseries ' strcat(ylabs,' -- ', ticker_a{1})]) 
set(get(AX(2),'Ylabel'),'String',['\bfseries ' strcat(ylabs,' -- ' , ticker_a{2})]) 

set(gca, 'TickDir', 'in', 'Box', 'off' ,'XMinorTick','Off','YMinorTick','Off','linewidth',1.5,'Xgrid','on','Ygrid','on'); % here gca means get current axis

set(get(AX(1),'Xlabel'),'interpreter','latex','FontSize',10);
set(get(AX(2),'Xlabel'),'interpreter','latex','FontSize',10);
set(get(AX(1),'Ylabel'),'interpreter','latex','FontSize',10);
set(get(AX(2),'Ylabel'),'interpreter','latex','FontSize',10);

if ~isempty(foc_time)
    foc_time_adj=foc_time-datenum('00:00');
    set(AX(1),'XLim',foc_time_adj)
    set(AX(2),'XLim',foc_time_adj)
    % tick labels
    xtdata_num=linspace(foc_time_adj(1),foc_time_adj(2),4);
    xtdata_str=datestr(xtdata_num,'HH:MM');
    set(AX(1),'XTickLabel',xtdata_str)
    set(AX(2),'XTickLabel',xtdata_str)
    foc_timel='_foct';
    if useTimeSec
        datetick(AX(1),'x','HH:MM:SS','keeplimits');
        datetick(AX(2),'x','HH:MM:SS','keeplimits');
    else
        datetick(AX(1),'x','HH:MM','keeplimits');
        datetick(AX(2),'x','HH:MM','keeplimits');
    end
else
    datetick(AX(1),'x','HH:MM');
    datetick(AX(2),'x','HH:MM');
    set(AX(1),'XLim',[9.5/24 16/24])
     set(AX(1),'XTick',(9:1:16)/24)
     set(AX(2),'XLim',[9.5/24 16/24])
     set(AX(2),'XTick',(9:1:16)/24)
    foc_timel='';
end


if ~isempty(comp_ylim)
    set(AX(1),'Ylim',comp_ylim(1,:))
    set(AX(2),'Ylim',comp_ylim(2,:))
    set(AX(1),'YTick',linspace(comp_ylim(1,1),comp_ylim(1,2),5));
    set(AX(2),'YTick',linspace(comp_ylim(2,1),comp_ylim(2,2),5));
    comp_yl='_compy';
else
    comp_yl='';
    ytickv1 = get(AX(1),'YTick');
    set(AX(1),'Ylim',[ytickv1(1),ytickv1(end)])
    set(AX(1),'YTick',linspace(ytickv1(1),ytickv1(end),5));
    ytickv2 = get(AX(2),'YTick');
    set(AX(2),'Ylim',[ytickv2(1),ytickv2(end)])
    set(AX(2),'YTick',linspace(ytickv2(1),ytickv2(end),5));
end

parent = get(h1(1),'Parent');
set(parent,'FontSize',10,'FontWeight','demi');    
parent = get(h2(1),'Parent');
set(parent,'FontSize',10,'FontWeight','demi');    

%# vertical line
if ~isempty(vertt)
    gridxy(vertt-datenum('00:00'), 'LineStyle','--', 'Color',rgb('black'),'linewidth',1.3)
end


% label vert
if ~isempty(vertt)
      vertl='_vl';
else
      vertl='';
end

% time in seconds
if  useTimeSec
     useTimeSec_str='_ts';            
else
     useTimeSec_str='';     
end

% save plot
nameout=strcat(outpath,'price_',ticker_a{1},'_',ticker_a{2},'_',source_d,'_',datestr(tdate,'yyyymmdd'),typed,'_',cl_str,rev_str,vertl, foc_timel,useTimeSec_str,...
comp_yl);

export_fig(nameout,'-pdf','-png');

% -------------------------------------------------------------------------
%   
else
    error('Data does not exist for chosen day!!!')
end

% -------------------------------------------------------------------------
%   
