%% run_plot_price_event_univ_08102016.m
%--------------------------------------------------------------------------
% plots intraday mid-quote path of assets together with vertical lines
% indicating events
%--------------------------------------------------------------------------
%
% Peter Malec, October 10, 2016
%
% -------------------------------------------------------------------------
%
%% Define INPUTS


% Clear system
clear all;
clc;

% add procs
myaddToPath;

% Choose basepath
basepath =1;              

% source of data
source_d='LOBSTER';           % UPPER CASE!

% Stock
ticker      ='AAPL'; % apr 13

% datatype
typed='quotes';           % midp: midquotes, quotes, trad: trades

% dates (entire period or spec dates)
tdate=datenum('6 may 10');

% start end end of trading (in hours)
startt=9.5;
endt=16;

%cleaning 
cl_ind=-1;           %if==1: cleaning is done

%revisions
rev_ind=-1;     %if ==1, only obs with price revisions are used

% time focus (from to )
foc_time=[datenum('14:40:00') datenum('14:40:10')];%[datenum('13:30') datenum('16:00')];

% time of vertline
vertt=[datenum('14:00')];   % in format HH:MM:ss: if empty: no vertical line 

% time in seconds
useTimeSec=true;

% pre-specified y limits for comparison
comp_ylim=[237,240];

% tdate=datenum('6 may 10');
% no foc
% text_pos_x=[datenum('14:00') datenum('14:35') datenum('14:37') datenum('14:46:11') datenum('15:01')];                   %different positions possible (empty if no labels)
% halign_a={'left','right','right','left','right'};           % horizontal alignment of text (left or right)
% long_ind_v=[1 1 0 1 1];                   % indicator for long arrow-> arrows need same dir as above.
% add_v=[0.5 -3 -3 0.5 -3]*0.00125;                           % correction (inr: 0.00125) for position of labels (positive if left, otherwise negative)
% foc
% text_pos_x=[datenum('14:00') datenum('14:35') datenum('14:37') datenum('14:46:11') datenum('15:01')];                   %different positions possible (empty if no labels)
% halign_a={'left','left','right','left','right'};           % horizontal alignment of text (left or right)
% long_ind_v=[1 0 0 1 1];                   % indicator for long arrow-> arrows need same dir as above.
% add_v=[0 -0.4 -1.3 0 -1.3]*0.00125;                           % correction (inr: 0.00125) for position of labels (positive if left,
%tdate=datenum('27 dec 12');
% text_pos_x=[datenum('10:00') datenum('14:20')];                   %different positions possible (empty if no labels)
% halign_a={'left','left'};           % horizontal alignment of text (left or right)
% long_ind_v=[1 1];                   % indicator for long arrow-> arrows need same dir as above.
% add_v=[1 1]*0.00125;                           % correction (inr: 0.00125) for position of labels (positive if left, otherwise negative)
% tdate=datenum('25 jan 13');
% no foc
% text_pos_x=[datenum('15:59')];                   %different positions possible (empty if no labels)
% halign_a={'right'};           % horizontal alignment of text (left or right)
% long_ind_v=[1];                   % indicator for long arrow-> arrows need same dir as above.
% add_v=[-3.5]*0.00125;                           % correction (inr: 0.00125) for position of labels (positive if left, otherwise ne
% foc
% text_pos_x=[datenum('15:59')];                   %different positions possible (empty if no labels)
% halign_a={'right'};           % horizontal alignment of text (left or right)
% long_ind_v=[1];                   % indicator for long arrow-> arrows need same dir as above.
% add_v=[-1]*0.00125;                           % correction (inr: 0.00125) for position of labels (positive if left, otherwise negative)
% tdate=datenum('23 apr 13');
% no foc
% text_pos_x=[datenum('13:07') datenum('13:10') datenum('13:14')];                   %different positions possible (empty if no labels)
% halign_a={'right','right','right'};           % horizontal alignment of text (left or right)
% long_ind_v=[1 1 1];                   % indicator for long arrow-> arrows need same dir as above.
% add_v=[-3.5 -3.5 -3.5]*0.00125;                           % correction (inr: 0.00125) for position of labels (positive if left, otherwise negative)
%  foc
% text_pos_x=[datenum('13:07') datenum('13:10') datenum('13:14')];                   %different positions possible (empty if no labels)
% halign_a={'left','left','right'};           % horizontal alignment of text (left or right)
% long_ind_v=[1 1 1];                   % indicator for long arrow-> arrows need same dir as above.
% add_v=[0 0 -0.3]*0.00125;                           % correction (inr: 0.00125) for position of labels (positive if left, otherwise negative)
% -------------------------------------------------------------------------
%
%% Determination of Basepath


if basepath ==1
    
    pathproject = '~//Projects//Spot_corr//MATLAB//';
    
elseif basepath ==2
    
    pathproject = '~//Spot_corr//MATLAB//';    
    
elseif basepath ==0
    
    pathproject = 'H:\\Spot_corr\\MATLAB\\';
    
elseif basepath ==-1
    
    pathproject = 'C:\\peter.malec\\Spot_corr\\MATLAB\\';            
    
    
elseif basepath ==-2
    
    pathproject = 'X:\\peter.malec\\Spot_corr\\MATLAB\\';            
    
else
    
    pathproject = 'H:\\Spot_corr\\MATLAB\\';
    
end
% -------------------------------------------------------------------------
%
%% Determination of In- and Outpath and Path for additional Data

inpath=strcat(pathproject,'Data',filesep,source_d,filesep,'Filtered',filesep);

addpath=strcat(pathproject,'Data',filesep,'Add',filesep);

outpath=strcat(pathproject,'Emp_AnA',filesep,'Plots',filesep);
% -------------------------------------------------------------------------
%
%% Either Quotes or Trades
    
    % clean?
if cl_ind==1
     cl_str='cl';            % cleaning string for output file
else
     cl_str='ncl';
end

% revisions?
if rev_ind==1
     rev_str='_rev';            
else
     rev_str='';     
end

% check existence of data
name1=strcat(inpath,ticker,filesep,ticker,'_',datestr(tdate,'yyyymmdd'),'_',typed,'_',cl_str,'.mat');
index1=isequal(exist(name1,'file'),2);

if index1
%---------------------------------------------------------

% load data
load(name1);
if isequal(typed,'trades')
   midprice1=trades;
else
    midprice1=midprice;
end
if isequal(typed,'quotes')
    midprice1=[midprice1,0.5*(midprice1(:,2)+midprice1(:,3))];
end
if rev_ind==1
    if ~isequal(typed,'quotes')
        midprice1=keep_rev(midprice1,2);
    else
        midprice1=keep_rev(midprice1,4);
    end
end
% -------------------------------------------------------------------------
%   
%% Plot

%ylabel
if isequal(typed,'trades')
    ylabs='Transaction Price';
elseif isequal(typed,'midp')
    ylabs='Mid-Quote';
elseif isequal(typed,'quotes')
    ylabs='Quote';
end

% normalize times
times_n1=midprice1(:,1)/(24*3600);   

% plot
%-----------------------------
fh=figure;
 
set(fh, 'color', 'white');

if ~isequal(typed,'quotes')
    h1=plot(times_n1,midprice1(:,2));
    set(h1(1),'LineStyle','none','Marker','*','MarkerFaceColor',rgb('black'),'MarkerEdgeColor',rgb('black'),'MarkerSize',1.4);
else
    h1=plot(times_n1,midprice1(:,2:3));
    set(h1(1),'LineStyle','none','Marker','o','MarkerFaceColor',rgb('black'),'MarkerEdgeColor',rgb('black'),'MarkerSize',2.8);
    set(h1(2),'LineStyle','none','Marker','+','MarkerFaceColor',rgb('black'),'MarkerEdgeColor',rgb('black'),'MarkerSize',3.8);
end

set(get(gca,'Xlabel'),'String','\bfseries Time of Day') 

set(gca,'XColor',rgb('black'),'YColor',rgb('black'));
               
set(get(gca,'Ylabel'),'String',['\bfseries ' ylabs]) 

set(gca, 'TickDir', 'in', 'Box', 'off' ,'XMinorTick','Off','YMinorTick','Off','linewidth',1.5,'Xgrid','on','Ygrid','on'); % here gca means get current axis

set(get(gca,'Xlabel'),'interpreter','latex','FontSize',10);
set(get(gca,'Ylabel'),'interpreter','latex','FontSize',10);

if ~isempty(foc_time)
    foc_time_adj=foc_time-datenum('00:00');
    set(gca,'XLim',foc_time_adj)
    set(gca,'XLim',foc_time_adj)
    % tick labels
    xtdata_num=linspace(foc_time_adj(1),foc_time_adj(2),4);
    xtdata_str=datestr(xtdata_num,'HH:MM');
    set(gca,'XTickLabel',xtdata_str)
    foc_timel='_foct';
    if useTimeSec
        datetick(gca,'x','HH:MM:SS','keeplimits');
    else
        datetick(gca,'x','HH:MM','keeplimits');
    end
else
    datetick(gca,'x','HH:MM');
    set(gca,'XLim',[9.5/24 16/24])
     set(gca,'XTick',(9:1:16)/24)
    foc_timel='';
end


if ~isempty(comp_ylim)
    set(gca,'Ylim',comp_ylim)
    set(gca,'YTick',linspace(comp_ylim(1),comp_ylim(2),5));
    comp_yl='_compy';
else
    comp_yl='';
    ytickv1 = get(gca,'YTick');
    set(gca,'Ylim',[ytickv1(1),ytickv1(end)])
    set(gca,'YTick',linspace(ytickv1(1),ytickv1(end),5));
end

parent = get(h1(1),'Parent');
set(parent,'FontSize',10,'FontWeight','demi');    

%# vertical line
if ~isempty(vertt)
    gridxy(vertt-datenum('00:00'), 'LineStyle','--', 'Color',rgb('black'),'linewidth',1.3)
end


% label vert
if ~isempty(vertt)
      vertl='_vl';
else
      vertl='';
end

% time in seconds
if  useTimeSec
     useTimeSec_str='_ts';            
else
     useTimeSec_str='';     
end

% save plot
nameout=strcat(outpath,'price_',ticker,'_',source_d,'_',datestr(tdate,'yyyymmdd'),typed,'_',cl_str,rev_str,vertl, foc_timel,useTimeSec_str,...
comp_yl);

export_fig(nameout,'-pdf','-png');

% -------------------------------------------------------------------------
%   
else
    error('Data does not exist for chosen day!!!')
end

% -------------------------------------------------------------------------
%   
