%% trading_days_23042013.m
%--------------------------------------------------------------------------
% Produces vector NYSE & NASDAQ trading days from 2009 to 2014
%--------------------------------------------------------------------------
%
%Peter Malec, April 23, 2013
% -------------------------------------------------------------------------
%
%% Define INPUTS


% Clear system
clear;
clc;

% Choose basepath
basepath = 2;              

% start and end date
startd=datenum('1 jan 07');
endd=datenum('31 dec 14');
% -------------------------------------------------------------------------
%
%% Determination of Basepath


if basepath ==1
    
    pathproject = '~//Projects//Spot_corr//MATLAB//';
    
elseif basepath ==2
    
    pathproject = '~//Spot_corr//MATLAB//';    
    
elseif basepath ==0
    
    pathproject = 'H:\\Spot_corr\\MATLAB\\';
    
elseif basepath ==-1
    
    pathproject = 'C:\\peter.malec\\Spot_corr\\MATLAB\\';            
    
    
elseif basepath ==-2
    
    pathproject = 'X:\\peter.malec\\Spot_corr\\MATLAB\\';            
    
else
    
    pathproject = 'H:\\Spot_corr\\MATLAB\\';
    
end
% -------------------------------------------------------------------------
%
%% Determination of Outpath


outpath=strcat(pathproject,'Data',filesep,'Add',filesep);
% -------------------------------------------------------------------------
%
%% Input of Holiday dates

hol_2007=[datenum('Jan 1 07')
	datenum('Jan 15 07')
	datenum('Feb 19 07')
    datenum('Apr 6 07')
datenum('May 28 07')
datenum('Jul 3  07 ')
datenum('Jul 4  07 ')
datenum('Sep 3 07')
datenum('Nov 21 07')
datenum('Nov 22 07')
datenum('Dec 24 07')
datenum('Dec 25 07')];


hol_2008=[datenum('Jan 1 08')
	datenum('Jan 21 08')
	datenum('Feb 18 08')
    datenum('Mar 21 08')
datenum('May 26 08')
datenum('Jul 3  08 ')
datenum('Jul 4  08 ')
datenum('Sep 1 08')
datenum('Nov 27 08')
datenum('Nov 28 08')
datenum('Dec 24 08')
datenum('Dec 25 08')];


hol_2009=[datenum('Jan 1 09')
	datenum('Jan 19 09')
	datenum('Feb 16 09')
	datenum('Apr 10 09')
datenum('May 25 09')
datenum('Jul 3  09 ')
datenum('Sep 7 09')
datenum('Nov 26 09')
datenum('Nov 27 09')
datenum('Dec 24 09')
datenum('Dec 25 09')];


hol_2010=[datenum('Jan 1 10')
	datenum('Jan 18 10')
	datenum('Feb 15 10')
	datenum('Apr 2 10')
datenum('May 31 10')
datenum('Jul 5  10 ')
datenum('Sep 6 10')
datenum('Nov 25 10')
datenum('Nov 26 10')
datenum('Dec 24 10')];



hol_2011=[
	datenum('Jan 17 11')
	datenum('Feb 21 11')
	datenum('Apr 22 11')
datenum('May 30 11')
datenum('Jul 4  11 ')
datenum('Sep 5 11')
datenum('Oct 17 11')
datenum('Nov 24 11')
datenum('Nov 25 11')
datenum('Dec 26 11')];


hol_2012=[
    datenum('Jan 2 12')
	datenum('Jan 16 12')
	datenum('Feb 20 12')
	datenum('Apr 6 12')
datenum('May 28 12')
datenum('Jul 3  12')
datenum('Jul 4  12')
datenum('Sep 3 12')
datenum('Oct 29 12')
datenum('Oct 30 12')
datenum('Nov 22 12')
datenum('Nov 23 12')
datenum('Dec 24 12')
datenum('Dec 25 12')];

hol_2013=[
    datenum('Jan 1 13')
	datenum('Jan 21 13')
	datenum('Feb 18 13')
	datenum('Mar 29 13')
        datenum('Apr 9 13')
    datenum('Apr 30 13')
datenum('May 27 13')
datenum('Jul 3 13 ')
datenum('Jul 4 13 ')
datenum('Aug 22 13 ')
datenum('Sep 2 13')
datenum('Nov 28 13')
datenum('Nov 29 13')
datenum('Dec 24 13')
datenum('Dec 25 13')];

hol_2014=[
    datenum('Jan 1 14')
	datenum('Jan 20 14')
	datenum('Feb 17 14')
        datenum('Apr 18 14')
datenum('May 26 14')
datenum('Jul 3 14 ')
datenum('Jul 4 14 ')
datenum('Sep 1 14')
datenum('Nov 27 14')
datenum('Nov 28 14')
datenum('Dec 24 14')
datenum('Dec 25 14')];

%merge holiday vectors

holv_vec=[hol_2007;hol_2008;hol_2009;hol_2010;hol_2011;hol_2012; hol_2013; hol_2014];
% -------------------------------------------------------------------------
%
%% Loop to Determine Trading Days

% Define date vector
date_v=startd:endd;

% Empty vector of trading day indicators
t_day_ind=ones(length(date_v),1);

% Vector of MATLAB indicators for Sunday and Saturday
weekend_ind=[1 7];

%start loop
for i=1:length(date_v)
    
    % choose date and determine corresponding weekday
    date_i=date_v(i);
    [wkd, wkd_s]=weekday(date_i);
    
    % drop day if it is a saturday or sunday or a holiday
    if (any(weekend_ind==wkd)) || (any(holv_vec==date_i))
        
         t_day_ind(i)=0;
        
    end

end
% -------------------------------------------------------------------------
%
%% Select Trading Days and Save Output


% create final date vector with logical use of trade day indicators
date_v=date_v(logical(t_day_ind));

% save output 
save(strcat(outpath,'trading_days.mat'),'date_v')






