function [Sinv C]=WoodburyInv_reg_fac(H_t,nof)
    % Woodbury Inversion of a Factor Covariance regularized by factor
    % structure
  %%%%%%%%%%%%%%
%Inputs
%%%%%%%%%%%%%%
% H_t >>> covariance estimate
% nof >>> number of factors
%%%%%%%%%%%%%%%%%
%Outputs
%%%%%%%%%%%%%%
% Sinv >>> inverse of regularized covarinace estimate
% C >>> diagonal matrix of eigenvalues
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[K,K]=size(H_t);

[U C Utr]=svds(H_t,nof);                %spectral decomp for regularization


V = U';

Sigma=U*C*V;                %factor covariance estimate (without diagonal correction)


A=diag(H_t(logical(eye(K)))-Sigma(logical(eye(K)))); % matrix D in paper



Ainv =diag(diag(A).^(-1));                      %exploit diagonal structure
    
    Cinv=diag(diag(C).^(-1));                       %exploit diagonal structure
  

    
    sum_bi=Cinv+V*Ainv*U;

Sinv = Ainv - Ainv*(U/sum_bi)*V*Ainv;               %do not use inv function >>imprecise
